VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "mswinsck.ocx"
Begin VB.UserControl ctlAOLProxy 
   ClientHeight    =   1095
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2265
   ScaleHeight     =   1095
   ScaleWidth      =   2265
   Begin VB.Timer Timer1 
      Interval        =   1
      Left            =   960
      Top             =   0
   End
   Begin MSWinsockLib.Winsock Winsock 
      Index           =   0
      Left            =   0
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin MSWinsockLib.Winsock Winsock 
      Index           =   1
      Left            =   480
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
End
Attribute VB_Name = "ctlAOLProxy"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private AOLServerAddress As String
Private AOLServerPort As Integer
Private AOLClientPort As Integer

Private AOLClientCount As Long
Private AOLServerCount As Long

Private ClientRemainder As String
Private ServerRemainder As String
Private PacketQueue As Collection
Private PacketSocket As Collection

Private FirstPacketDone As Boolean
Private UseStandAlone As Boolean

Public Event GotPacketServer(sPacket As String)
Public Event GotPacketClient(sPacket As String)
Public Event PacketCountModified(PacketCount As Long)
Public Event AOLproxyStatus(Status As String)

Private Sub UserControl_Initialize()

    On Error Resume Next
    
    AOLClientPort% = 5190
    
    AOLServerAddress$ = "Americaonline.aol.com"
    
    AOLServerPort% = 5190
    
    Set PacketQueue = New Collection
    
    Set PacketSocket = New Collection
    
End Sub

Private Sub QueueData(Data As String, WinsockIndex As Integer)

    On Error GoTo QueueDataErr 'If we ever hit this it's a major problem

    Dim PacketLength As Long

    Select Case WinsockIndex%
        
        Case 0 'Client
                
            If Len(Data$) < 12 Then
                    
                ClientRemainder$ = Data$
                    
                Exit Sub
                
            End If
                
            If ClientRemainder$ = vbNullString Then
                    
                PacketLength& = Hex2LngVar$(Mid$(Data$, 9, 4), 4) + 6
                
            Else
                    
                Data$ = ClientRemainder$ & Data$
                    
                ClientRemainder$ = vbNullString
                    
                PacketLength& = Hex2LngVar$(Mid$(Data$, 9, 4), 4) + 6
                
            End If
                
            If Len(Data$) < PacketLength& * 2 Then
                    
                ClientRemainder$ = Data$
                    
                Exit Sub
                
            End If
                
            If Len(Data$) > PacketLength& * 2 Then
                    
                RaiseEvent GotPacketClient(Mid$(Data$, 1, PacketLength& * 2))
                    
                Data$ = Mid$(Data$, PacketLength& * 2 + 1)
                    
                Call QueueData(Data$, WinsockIndex%)
                
            Else 'Data is exact length
                    
                RaiseEvent GotPacketClient(Data$)
    
            End If
        
        Case 1 'AOL server
                
            If Len(Data$) < 12 Then
                    
                ServerRemainder$ = Data$
                    
                Exit Sub
                
            End If
                
            If ServerRemainder$ = vbNullString Then
                    
                PacketLength& = Hex2LngVar$(Mid$(Data$, 9, 4), 4) + 6
                
            Else
                    
                Data$ = ServerRemainder$ & Data$
                    
                ServerRemainder$ = vbNullString
                    
                If Mid$(Data$, 1, 3) <> "2A0" Then
                        
                    ServerRemainder$ = vbNullString
                        
                    Exit Sub
                    
                End If
                    
                PacketLength& = Hex2LngVar$(Mid$(Data$, 9, 4), 4) + 6
                
            End If
                
            If Len(Data$) < PacketLength& * 2 Then
                    
                ServerRemainder$ = Data$
                    
                Exit Sub
                
            End If
                
            If Len(Data$) > PacketLength& * 2 Then
                    
                RaiseEvent GotPacketServer(Mid$(Data$, 1, PacketLength& * 2))
    
                Data$ = Mid$(Data$, PacketLength& * 2 + 1)
                    
                Call QueueData(Data$, WinsockIndex%)
            
            Else
                
                RaiseEvent GotPacketServer(Data$)
    
            End If
        
    End Select
    
    Exit Sub
    
QueueDataErr:

    Exit Sub
    
End Sub

Private Function ProcessCounter(Index As Integer) As String

    On Error Resume Next

    Select Case Index%
    
        Case 0
            
            AOLClientCount& = AOLClientCount& + 1
            
            If AOLClientCount& > 65535 Then AOLClientCount& = 0
            
            ProcessCounter = EnHex$(LngToBase256$(AOLClientCount&))
            
        Case 1 'Server
            
            AOLServerCount& = AOLServerCount& + 1
            
            If AOLServerCount& > 65535 Then AOLServerCount& = 0
            
            ProcessCounter$ = EnHex$(LngToBase256$(AOLServerCount&))
            
    End Select
    
End Function

Private Function ReplaceCounter(isClient As Boolean, HexData As String) As String

    On Error Resume Next

    Select Case isClient
        
        Case True
            
            ReplaceCounter$ = Mid$(HexData$, 1, 4) & ProcessCounter$(0) & Mid$(HexData$, 9)
        
        Case False
            
            ReplaceCounter$ = Mid$(HexData$, 1, 4) & ProcessCounter$(1) & Mid$(HexData$, 9)
    
    End Select

End Function

Public Sub ProxySendClient(sPacket As String)

    On Error Resume Next

    PacketQueue.Add DeHex$(ReplaceCounter$(False, sPacket$))
    
    PacketSocket.Add "0"

End Sub


Public Sub ProxySendServer(sPacket As String)

    On Error Resume Next

    PacketQueue.Add DeHex$(ReplaceCounter$(True, sPacket$))
    
    PacketSocket.Add "1"

End Sub

Public Sub EnableProxy()

    On Error Resume Next

    If Winsock(0).State = sckConnected Then Exit Sub
    
    Winsock(0).LocalPort = AOLClientPort%
    
    Winsock(0).Close
    
    Winsock(1).Close
    
    Winsock(0).Listen
    
    RaiseEvent AOLproxyStatus("Listening")
    
End Sub

Public Sub DisableProxy()

    On Error Resume Next
    
    Winsock(0).Close
    
    Winsock(1).Close
    
    RaiseEvent AOLproxyStatus("Disabled")
    
End Sub

Public Sub StandAlone(Setting As Integer)
    
    On Error Resume Next
    
    If Setting% = "1" Then
        
        Winsock(0).Close
        UseStandAlone = True

    Else
        
        UseStandAlone = False
        Call EnableProxy

    End If

End Sub

Public Sub SetClientPort(Port As Integer)

    AOLClientPort% = Port%
    
End Sub

Public Sub SetServerPort(Port As Integer)

    AOLServerPort% = Port%
    
End Sub

Public Sub SetServerAddress(Address As String)

    AOLServerAddress$ = Address$
    
End Sub

Public Function GetClientPort() As String

    GetClientPort$ = AOLClientPort%

End Function

Public Function GetServerPort() As String

    GetServerPort$ = AOLServerPort%

End Function

Public Function GetServerAddress() As String

    GetServerAddress$ = AOLServerAddress$

End Function

Private Sub Timer1_Timer()

    On Error Resume Next

    If PacketQueue.Count > 0 Then
        
        Dim tmpTemp As String, TmpInt As Integer
        
        tmpTemp$ = PacketQueue.Item(1)
        
        TmpInt% = Val(PacketSocket.Item(1)) 'socket index it is going to
        
        If Winsock(TmpInt%).State <> 7 And UseStandAlone = False Then Exit Sub
        
        PacketQueue.Remove (1)
        
        PacketSocket.Remove (1)
        
        Winsock(TmpInt%).SendData tmpTemp$

    End If
    
End Sub

Private Sub Winsock_ConnectionRequest(Index As Integer, ByVal RequestID As Long)

    On Error Resume Next
    
    If Winsock(0).State <> sckConnected Then
        
        Winsock(0).Close
        
        Winsock(0).Accept RequestID&
        
        Winsock(1).Close
        
        Winsock(1).Connect AOLServerAddress$, AOLServerPort%
        
        RaiseEvent AOLproxyStatus("Connected")
    
    End If
    
End Sub

Private Sub Winsock_DataArrival(Index As Integer, ByVal bytesTotal As Long)

    On Error Resume Next
    
    Dim DataGot As String
    
    Winsock(Index%).GetData DataGot$
    
    If FirstPacketDone = False Then
        
        If Mid$(DataGot$, 1, 1) = "*" Then
            
            FirstPacketDone = True
        
        Else
            
            Call EnableProxy
            
            MsgBox "Unrecognized protocol, resetting connection.", vbOKOnly, "iCOM"
            
            Exit Sub
        
        End If
    
    End If
    
    Call QueueData(EnHex$(DataGot$), Index%)
    
End Sub
