VERSION 5.00
Object = "{0144D7BA-695E-4473-AD28-7BD0543DD399}#1.0#0"; "XPButtons.ocx"
Begin VB.Form frmReconnect 
   BackColor       =   &H0063699C&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Re-Connecting"
   ClientHeight    =   2190
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   4140
   Icon            =   "frmReconnect.frx":0000
   LinkTopic       =   "frmReconnect"
   MaxButton       =   0   'False
   ScaleHeight     =   2190
   ScaleWidth      =   4140
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrReConnect 
      Enabled         =   0   'False
      Interval        =   30000
      Left            =   4440
      Top             =   1080
   End
   Begin VB.PictureBox pictPanel 
      Appearance      =   0  'Flat
      BackColor       =   &H00404080&
      ForeColor       =   &H80000008&
      Height          =   1935
      Index           =   0
      Left            =   120
      ScaleHeight     =   1905
      ScaleWidth      =   3825
      TabIndex        =   0
      Top             =   120
      Width           =   3855
      Begin VB.ListBox lstReconnectAttempts 
         Appearance      =   0  'Flat
         BackColor       =   &H00404080&
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00FFFFFF&
         Height          =   1290
         Left            =   120
         TabIndex        =   1
         Top             =   120
         Width           =   3615
      End
      Begin XPButtons.XPButton cmdStopReconnects 
         Height          =   255
         Left            =   720
         TabIndex        =   2
         Top             =   1560
         Width           =   2415
         _ExtentX        =   4260
         _ExtentY        =   450
         BTYPE           =   6
         TX              =   "Stop Re-Connections"
         ENAB            =   -1  'True
         BeginProperty FONT {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
            Name            =   "Arial"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         COLTYPE         =   2
         BCOL            =   4210816
         FCOL            =   16777215
         FCOLO           =   0
         EMBOSSM         =   12632256
         EMBOSSS         =   16777215
         MPTR            =   0
         MICON           =   "frmReconnect.frx":1F8FA
         ALIGN           =   1
         IMGLST          =   "(None)"
         IMGICON         =   "(None)"
         ICONAlign       =   0
         ORIENT          =   0
         STYLE           =   0
         IconSize        =   2
         SHOWF           =   -1  'True
         BSTYLE          =   0
      End
   End
End
Attribute VB_Name = "frmReconnect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private LevReconnect As Integer, ChatIndex As Integer

Public Sub SetTypeOfReconnect(ReconnectLevel As Integer, Optional Index As Integer = "54")
    '0 - AIM Owner logoff
    '1 - AOL CCOM logoff
    '2 - AIM Owner Chat left
    '3 - AOL CCOM Chat left
    
    LevReconnect% = ReconnectLevel%
    
    If LevReconnect% = "0" Then
        'Retry Login
        lstReconnectAttempts.AddItem "Re-Connecting: AIM Owner: Sign On"
        
        Call frmMain.iCOMParser.LoginOwner(frmMain.txtScreenName.Text$, frmMain.txtPassword.Text$, frmMain.txtServer.Text$, frmMain.txtPort.Text$)
    
    ElseIf LevReconnect% = "1" Then
        'Retry AOL CCOM login
        lstReconnectAttempts.AddItem "Re-Connecting: AOL CCOM: Sign On"
                
    ElseIf LevReconnect% = "2" Then
        'Retry AIM Owner Rejoin
        lstReconnectAttempts.AddItem "Re-Connecting: AIM Owner: Chat Join"
        
        Call frmMain.iCOMParser.JoinRoom(frmMain.txtRoomName.Text$, frmMain.txtExchange.Text$, "0", False)
        
    ElseIf LevReconnect% = "3" Then
        'Retry AOL CCOM rejoin
        lstReconnectAttempts.AddItem "Re-Connecting: AOL CCOM: Chat Join"
                
    End If
    
    If ChatIndex% = "54" Then
        
        Exit Sub
        
    End If
    
    ChatIndex% = Index%
    
End Sub

Private Sub cmdStopReconnects_Click()
    
    frmMain.chkAttemptReconnect.Value = vbUnchecked
    
    If LevReconnect% = "0" Then
        'Stop login
        tmrReConnect.Enabled = False
        
    ElseIf LevReconnect% = "1" Then
        'Stop AOL CCOM login
        tmrReConnect.Enabled = False
    
    ElseIf LevReconnect% = "2" Then
        'Stop AIM Owner Rejoin
        
        tmrReConnect.Enabled = False
 
    ElseIf LevReconnect% = "3" Then
        'Stop AOL CCOM rejoin
        tmrReConnect.Enabled = False
        
    End If
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    tmrReConnect.Enabled = False
    
End Sub

Public Sub ReConnect()

    tmrReConnect.Enabled = True

End Sub

Private Sub tmrReConnect_Timer()
    
    If LevReconnect% = "0" Then
        'Retry Login
        lstReconnectAttempts.AddItem "Re-Connecting: AIM Owner: Sign On"
        
        Call frmMain.iCOMParser.LoginOwner(frmMain.txtScreenName.Text$, frmMain.txtPassword.Text$, frmMain.txtServer.Text$, frmMain.txtPort.Text$)
    
    ElseIf LevReconnect% = "1" Then
        'Retry AOL CCOM login
        lstReconnectAttempts.AddItem "Re-Connecting: AOL CCOM: Sign On"
                
    ElseIf LevReconnect% = "2" Then
        'Retry AIM Owner Rejoin
        lstReconnectAttempts.AddItem "Re-Connecting: AIM Owner: Chat Join"
        
        Call frmMain.iCOMParser.JoinRoom(frmMain.txtRoomName.Text$, frmMain.txtExchange.Text$, "0", False)
        
    ElseIf LevReconnect% = "3" Then
        'Retry AOL CCOM rejoin
        lstReconnectAttempts.AddItem "Re-Connecting: AOL CCOM: Chat Join"
                
    End If
    
End Sub
